/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package vip.xiaonuo.biz.modular.couponconfig.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import jakarta.annotation.Resource;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import vip.xiaonuo.common.enums.CommonSortOrderEnum;
import vip.xiaonuo.common.exception.CommonException;
import vip.xiaonuo.common.page.CommonPageRequest;
import vip.xiaonuo.biz.modular.couponconfig.entity.CouponConfig;
import vip.xiaonuo.biz.modular.couponconfig.mapper.CouponConfigMapper;
import vip.xiaonuo.biz.modular.couponconfig.param.CouponConfigAddParam;
import vip.xiaonuo.biz.modular.couponconfig.param.CouponConfigEditParam;
import vip.xiaonuo.biz.modular.couponconfig.param.CouponConfigIdParam;
import vip.xiaonuo.biz.modular.couponconfig.param.CouponConfigPageParam;
import vip.xiaonuo.biz.modular.couponconfig.service.CouponConfigService;
import vip.xiaonuo.dev.api.DevConfigApi;

import java.util.List;

/**
 * 蛋糕券配置Service接口实现类
 *
 * @author fanzherong
 * @date  2025/04/14 10:32
 **/
@Service
public class CouponConfigServiceImpl extends ServiceImpl<CouponConfigMapper, CouponConfig> implements CouponConfigService {

    @Resource
    private DevConfigApi devConfigApi;

    @Override
    public Page<CouponConfig> page(CouponConfigPageParam couponConfigPageParam) {
        QueryWrapper<CouponConfig> queryWrapper = new QueryWrapper<CouponConfig>().checkSqlInjection();
        if(ObjectUtil.isNotEmpty(couponConfigPageParam.getRechargePlanId())){
            queryWrapper.lambda().eq(CouponConfig::getRechargePlanId,couponConfigPageParam.getRechargePlanId());
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(CouponConfigAddParam couponConfigAddParam) {
        CouponConfig couponConfig = BeanUtil.toBean(couponConfigAddParam, CouponConfig.class);
        this.save(couponConfig);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(CouponConfigEditParam couponConfigEditParam) {
        CouponConfig couponConfig = this.queryEntity(couponConfigEditParam.getId());
        BeanUtil.copyProperties(couponConfigEditParam, couponConfig);
        this.updateById(couponConfig);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<CouponConfigIdParam> couponConfigIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(couponConfigIdParamList, CouponConfigIdParam::getId));
    }

    @Override
    public CouponConfig detail(CouponConfigIdParam couponConfigIdParam) {
        return this.queryEntity(couponConfigIdParam.getId());
    }

    @Override
    public CouponConfig queryEntity(String id) {
        CouponConfig couponConfig = this.getById(id);
        if(ObjectUtil.isEmpty(couponConfig)) {
            throw new CommonException("蛋糕券配置不存在，id值为：{}", id);
        }
        return couponConfig;
    }

    @Override
    public List<CouponConfig> getList(CouponConfigPageParam couponConfigPageParam) {
        List<CouponConfig> couponConfigList = this.list(new QueryWrapper<CouponConfig>().lambda().
                eq(CouponConfig::getRechargePlanId,couponConfigPageParam.getRechargePlanId()));
        return couponConfigList;
    }

    @Override
    public List<CouponConfig> getMemberList(CouponConfigPageParam couponConfigPageParam) {
        //充值方案id
        String planId = devConfigApi.getValueByKey("SNOWY_GIFT_COUPON");
        List<CouponConfig> couponConfigList = this.list(new QueryWrapper<CouponConfig>().lambda().
                eq(CouponConfig::getRechargePlanId,planId));
        return couponConfigList;
    }
}
